; ADDFRM.LSP
; Copyright (c) Barry R. Bowen 1993
; ----------------------------------------------------------

(defun D90 () (* pi 0.5))

(defun ADDFRM ()
  (V3)
  (LS "DATUM" "3" "")
  (setq LP (getpoint "\nFrame Location Point: ")
        TS (getvar "textsize")
; ------------------ Place Characteristic Symbol
        FP1 LP
        FP2 (polar FP1 (D90) (* TS 2.0))
        FP3 (polar FP2 0 (* TS 3.5))
        FP4 (polar FP1 0 (* TS 3.5))
        GPT (polar (polar FP1 0 
            (/ (* TS 3.5) 2.0)) (D90) TS))
  (command "insert" SYM GPT TS "" ""
           "pline" FP1 FP2 FP3 FP4 "c")
; ------------------ Tolerance Zone
  (if (or (= TZS "None") (= TZS nil))
    (progn
      (setq TVPT (polar (polar FP4 0 (* TS 2.25)) (D90) TS))
      (command "text" "m" TVPT TS 0 TV)
      (if (= MTLC nil)
        (progn
          (setq FP5 (polar FP3 0 (* TS 4.5))
                FP6 (polar FP4 0 (* TS 4.5)))
          (command "pline" FP3 FP5 FP6 FP4 "")
        ) ;end progn
        (progn
          (setq MCPT (polar TVPT 0 (* TS 3.0))
                FP5 (polar FP3 0 (* TS 7.0))
                FP6 (polar FP4 0 (* TS 7.0)))
          (command "pline" FP3 FP5 FP6 FP4 ""
                   "insert" MTLC MCPT TS "" "")
        );end 2nd progn
      ) ; end if
    ) ;end 1st progn
; --------------------- If shape of tolerance zone added
    (progn
      (setq SMPT (polar GPT 0 (* TS 3.0)))
      (command "insert" TZS SMPT TS "" "")
      (setq TVPT (polar SMPT 0 (* TS 2.5)))
      (command "text" "m" TVPT TS 0 TV)
      (if (= MTLC nil)
        (progn
          (setq FP5 (polar FP3 0 (* TS 6.0))
                FP6 (polar FP4 0 (* TS 6.0)))
          (command "pline" FP3 FP5 FP6 FP4 "")
        ) ;end progn
        (progn
          (setq MCPT (polar TVPT 0 (* TS 3.0))
                FP5 (polar FP3 0 (* TS 8.5))
                FP6 (polar FP4 0 (* TS 8.5)))
          (command "pline" FP3 FP5 FP6 FP4 ""
                   "insert" MTLC MCPT TS "" "")
        );end 2nd progn
      ) ; end if
    );end 2nd progn
  ); end if
  (setq MPT (polar FP6 (D90) TS))
  (if (/= DR1 nil) (ADDATUM DR1 MAT1))
  (if (/= DR2 nil) (ADDATUM DR2 MAT2))
  (if (/= DR3 nil) (ADDATUM DR3 MAT3))
  (setq TZS nil SYM nil)
  (RL)
  (V4)
)

; ----------------- Add Datum References -----------------
(defun ADDATUM (DR DM)
  (setq DRP1 (polar MPT 0 (* TS 0.87))
        FP7 (polar FP5 0 (* TS 1.75))
        FP8 (polar FP6 0 (* TS 1.75)))
  (command "text" "m" DRP1 TS 0 DR)
  (if (/= DM nil)
   (progn
    (setq MP1 (polar MPT 0 (* TS 2.5))
          FP7 (polar FP5 0 (* TS 4.0))
          FP8 (polar FP6 0 (* TS 4.0)))
    (command "insert" DM MP1 TS "" "")
   );end progn
  );end if
  (command "pline" FP5 FP7 FP8 FP6 "")
  (setq FP5 FP7 FP6 FP8 MPT (polar FP6 (D90) TS))
)

; ------------------------- LS -----------------------------
; Layer search command for creating new layers.

(defun LS (NLAY CLR LT)
 (setq CL (getvar "clayer"))
 (setq LAY (tblsearch "layer" NLAY))
 (if (not LAY)
   (command "layer" "m" NLAY "c" CLR "" "lt" LT "" "");True
    (progn
      (setq FRZ (cdr (assoc 70 LAY)))
      (if (= FRZ 65)
        (progn
         (command "layer" "t" NLAY "")
         (command "layer" "s" NLAY "")
        )
         (command "layer" "s" NLAY "") ;False
))  ) )

; --------------------------- RL ---------------------------
(defun RL () (command "layer" "s" CL ""))

; -------------------------- V3 ----------------------------
(defun V3 ()
  (setq BM (getvar "blipmode"))
  (setvar "blipmode" 0)
  (setvar "cmdecho" 0)
  (command "undo" "group")
)

; -------------------------- V4 ----------------------------
(defun V4 (/ BA)
  (setvar "blipmode" BM)
  (command "undo" "end")
  (prompt "\n")
  (setq BA "Program Completed. . . . .")
)

(prompt "\nGTOL Loaded!...Copyright Barry R. Bowen 1993")
(princ)
