; SHAPES.LSP
;   by Andrew C. Clarey

; SHAPES.lsp is a lisp routine which will draw a dimensioned, 3 view drawing 
; of 8 different stock type materials, to user specified dimensions.

(defun SETTINGS ()   ;Setup Settings and Layers for Routine 
   (setq CMD(getvar "CMDECHO")
      CL(getvar "CLAYER")
      DLI(getvar "DIMDLI")
      DT(getvar "DIMTXT")
      DA(getvar "DIMASZ")
   PREC(getvar "LUPREC"))
   (setvar "CMDECHO" 0)
   (setvar "DIMTXT" 0.1)
   (setvar "DIMASZ" 0.1)
   (command "LAYER" "M" "OBJECT" "C" 5 "" "L" "CONTINUOUS" "" nil)
   (command "LAYER" "M" "HIDDEN" "C" 6 "" "L" "HIDDEN" "" nil)
   (command "LAYER" "M" "DIMENSION" "C" 3 "" "L" "CONTINUOUS" "" nil)
) 
(defun FLAT ()   ;Flat Bar
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      WIDTH(getreal "\nEnter Width of Flat Bar: ")
      LENGTH(getreal "\nEnter Overall Length of Flat Bar: ")
      THICK(getreal "\nEnter Thickness of Flat Bar: ")
      PT1(polar ORIGIN pi WIDTH)
      PT2(polar PT1 (/ pi 2.0) THICK)
      PT3(polar PT2 0.0 WIDTH)
      H1(polar ORIGIN (-(/ pi 2.0)) DLI)
   V1(polar PT1 pi DLI))
   (command "LAYER" "S" "OBJECT" "" "LINE" ORIGIN PT1 PT2 PT3 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" ORIGIN PT1 H1 ""
   "VERTICAL" PT2 PT1 V1 "" nil)
   (setq PT4(polar PT1 pi SPACE)
      PT5(polar PT4 (/ pi 2.0) THICK)
      PT6(polar PT4 pi LENGTH)
   PT7(polar PT5 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT4 PT5 PT7 PT6 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT4 PT6 H1 "" nil) 
   (setq PT8(polar PT5 (/ pi 2.0) SPACE)
      PT9(polar PT8 (/ pi 2.0) WIDTH)
      PT10(polar PT8 pi LENGTH)
   PT11(polar PT9 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT9 PT11 PT10 "C")
)        
(defun ANGLE ()  ;Angle
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      BASE(getreal "\nEnter Base Length: ")
      SIDE(getreal "\nEnter Side Length: ")
      LENGTH(getreal "\nEnter Overall Angle Length: ")
      THICK(getreal "\nEnter Material Thickness: ")
      PT1(polar ORIGIN pi BASE)
      PT2(polar PT1 (/ pi 2) THICK)
      PT3(polar PT2 0.0 (- BASE THICK))
      PT4(polar PT3 (/ pi 2)(- SIDE THICK))
   PT5(polar PT4 0.0 THICK))
   (command "LAYER" "S" "OBJECT" "" "LINE" ORIGIN PT1 PT2 PT3 PT4 PT5 "C")
   (setq H1(polar PT4 (/ pi 2) DLI)
      H2(polar ORIGIN (-(/ pi 2)) DLI)
      V1(polar ORIGIN 0.0 DLI)
   V2(polar PT2 pi DLI))
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT4 PT5 H1 "" "HORIZONTAL" 
   ORIGIN PT1 H2 "" "VERTICAL" ORIGIN PT5 V1 "" "VERTICAL" PT1 PT2 V2 "" nil)
   (setq PT6(polar PT1 pi SPACE)
      PT7(polar PT6 (/ pi 2.0) THICK)
      PT8(polar PT6 (/ pi 2.0) SIDE)
      PT9(polar PT6 pi LENGTH)
      PT10(polar PT7 pi LENGTH)
   PT11(polar PT8 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT6 PT9 "" "LINE" PT7 PT10 "" "LINE"
   PT8 PT11 "" "LINE" PT6 PT8 "" "LINE" PT9 PT11 "")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT6 PT9 H2 "" nil)
   (setq PT12(polar PT8 (/ pi 2) SPACE)
      PT13(polar PT12 (/ pi 2)(- BASE THICK))
      PT14(polar PT13 (/ pi 2) THICK)
      PT15(polar PT12 pi LENGTH)
      PT16(polar pt13 pi LENGTH)
   PT17(polar pt14 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT12 PT15 "" "LINE" PT13 PT16 ""
   "LINE" PT14 PT17 "" "LINE" PT12 PT14 "" "LINE" PT15 PT17 "")
)
(defun CHANNEL ()      ;Channel
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      BASE(getreal "\nEnter Base Length: ")
      LHSIDE(getreal "\nEnter Left Side Length: ")
      RHSIDE(getreal "\nEnter Right Side Length: ")
      LENGTH(getreal "\nEnter Overall Length: ")
      THICK(getreal "\nEnter Material Thickness: ")
      PT1(polar ORIGIN pi BASE)
      PT2(polar PT1 (/ pi 2.0) LHSIDE)
      PT3(polar PT2 0.0 THICK)
      PT4(polar PT3 (-(/ pi 2.0))(- LHSIDE THICK))
      PT5(polar PT4 0.0 (- BASE(* THICK 2.0)))
      PT6(polar PT5 (/ pi 2.0)(- RHSIDE THICK))
      PT7(polar PT6 0.0 THICK)
      H1(polar ORIGIN(-(/ pi 2.0)) DLI)
      V1(polar PT1 pi DLI)
      V2(polar ORIGIN 0.0 DLI)
   V3(polar V1 pi DLI))
   (command "LAYER" "S" "OBJECT" "" "LINE" ORIGIN PT1 PT2 PT3 PT4 PT5 PT6 PT7 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" ORIGIN PT1 H1 ""
      "VERTICAL" PT1 PT2 V3 "" "VERTICAL" PT4 PT1 V1 "" "VERTICAL" ORIGIN
   PT7 V2 "" nil)
   (setq PT8(polar PT1 pi SPACE)
      PT9(polar PT8 (/ pi 2.0) THICK)
      PT10(polar PT8 (/ pi 2.0) LHSIDE)
      PT11(polar PT8 (/ pi 2.0) RHSIDE)
      PT12(polar PT8 pi LENGTH)
      PT13(polar PT9 pi LENGTH)
      PT14(polar PT10 pi LENGTH)
   PT15(polar PT11 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT12 "" "LINE" PT10 PT14 "" "LAYER"
   "S" HIDDEN "" "LINE" PT9 PT13 "")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT8 PT12 H1 "" nil)
   (if(=(cadr PT10)(cadr PT11))
      (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT11 "" "LINE" PT12 PT15 "")
      (setq PT16(polar PT11 (/ pi 2.0) SPACE))
   )
   (if(>(cadr PT10)(cadr PT11))
      (command "LAYER" "S" "HIDDEN" "" "LINE" PT11 PT15 "" "LAYER" "S" "OBJECT"
      "" "LINE" PT8 PT10 "" "LINE" PT12 PT14 "")
      (setq PT16(polar PT11 (/ pi 2.0) SPACE))
   )
   (if(<(cadr PT10)(cadr PT11))
      (command "LAYER" "S" "OBJECT" "" "LINE" PT11 PT15 "" "LINE" PT8 PT11 ""
      "LINE" PT12 PT15 "")
      (setq PT16(polar PT10 (/ pi 2.0) SPACE))
   )
   (setq PT17(polar PT16 (/ pi 2.0) THICK)
      PT18(polar PT17 (/ pi 2.0) (- BASE(* THICK 2.0)))
      PT19(polar PT18 (/ pi 2.0) THICK)
      PT20(polar PT16 pi LENGTH)
      PT21(polar PT17 pi LENGTH)
      PT22(polar PT18 pi LENGTH)
   PT23(polar PT19 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT16 PT20 "" "LINE" PT19 PT23 "" "LINE"
   PT17 PT21 "" "LINE" PT18 PT22 "" "LINE" PT16 PT19 "" "LINE" PT20 PT23 "")
)
(defun SQUARET ()   ;Square Tube
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      BASE(getreal "\nEnter Base Length: ")
      SIDE(getreal "\nEnter Side Length: ")
      LENGTH(getreal "\nEnter Overall Length: ")
      THICK(getreal "\nEnter Material Thickness: ")
      PT1(polar ORIGIN pi BASE)
      PT2(polar PT1 (/ pi 2.0) SIDE)
      PT3(polar PT2 0.0 BASE)
      PT4(polar ORIGIN (/ 135(/ 180 pi)) (sqrt(+(* THICK THICK)(* THICK THICK))))
      PT5(polar PT4 pi (- BASE(* THICK 2.0)))
      PT6(polar PT5 (/ pi 2.0) (- SIDE(* THICK 2.0)))
      PT7(polar PT6 0.0 (- BASE(* THICK 2.0)))
      H1(polar ORIGIN (-(/ pi 2.0)) DLI)
      V1(polar PT1 pi DLI)
   V2(polar ORIGIN 0.0 DLI))
   (command "LAYER" "S" "OBJECT" "" "LINE" ORIGIN PT1 PT2 PT3 "C" "LINE" PT4 PT5
   PT6 PT7 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" ORIGIN PT1 H1 "" "VERTICAL"
   PT1 PT2 V1 "" "VERTICAL" ORIGIN PT4 V2 "" nil)
   (setq PT8(polar PT1 pi SPACE)
      PT9(polar PT8 (/ pi 2.0) THICK)
      PT10(polar PT9 (/ pi 2.0)(- SIDE(* THICK 2.0)))
      PT11(polar PT10 (/ pi 2.0) THICK)
      PT12(polar PT8 pi LENGTH)
      PT13(polar PT9 pi LENGTH)
      PT14(polar PT10 pi LENGTH)
   PT15(polar PT11 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT12 "" "LINE" PT11 PT15 "")
   (command "LAYER" "S" "HIDDEN" "" "LINE" PT9 PT13 "" "LINE" PT10 PT14 "")
   (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT11 "" "LINE" PT12 PT15 "")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT8 PT12 H1 "" nil)
   (setq PT16(polar PT11 (/ pi 2.0) SPACE)
      PT17(polar PT16 (/ pi 2.0) THICK)
      PT18(polar PT17 (/ pi 2.0) (- BASE(* THICK 2.0)))
      PT19(polar PT18 (/ pi 2.0) THICK)
      PT20(polar PT16 pi LENGTH)
      PT21(polar PT17 pi LENGTH)
      PT22(polar PT18 pi LENGTH)
   PT23(polar PT19 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT16 PT20 "" "LINE" PT19 PT23 "")
   (command "LAYER" "S" "HIDDEN" "" "LINE" PT17 PT21 "" "LINE" PT18 PT22 "")
   (command "LAYER" "S" "OBJECT" "" "LINE" PT16 PT19 "" "LINE" PT20 PT23 "")  
)
(defun SQUARES ()     ;Square Stock
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      SIDE(getreal "\nEnter Length of Side: ")
      LENGTH(getreal "\nEnter Overall Length: ")
      PT1(polar ORIGIN pi SIDE)
      PT2(polar PT1 (/ pi 2.0) SIDE)
      PT3(polar PT2 0.0 SIDE)
      H1(polar PT1 (-(/ pi 2.0)) DLI)
   V1(polar PT1 pi DLI))
   (command "LAYER" "S" "OBJECT" "" "LINE" ORIGIN PT1 PT2 PT3 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" ORIGIN PT1 H1 "" "VERTICAL"
   PT2 PT1 V1 "" nil)
   (setq PT4(polar PT1 pi SPACE)
      PT5(polar PT4 (/ pi 2.0) SIDE)
      PT6(polar PT4 pi LENGTH)
   PT7(polar PT5 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT4 PT5 PT7 PT6 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT4 PT6 H1 "" nil)
   (setq PT8(polar PT5 (/ pi 2.0) SPACE)
      PT9(polar PT8 (/ pi 2.0) SIDE)
      PT10(polar PT8 pi LENGTH)
   PT11(polar PT9 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT8 PT9 PT11 PT10 "C")
)        
(defun ROUNDS ()         ;Round Stock
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      DIA(getreal "\nEnter Diameter of Round Stock: ")
      RAD(/ DIA 2.0)
      LENGTH(getreal "\nEnter Overall Length of Round Stock: ")
      START(list(-(car ORIGIN)RAD)(+(cadr ORIGIN)RAD))
      PT1(list(-(car START)(+ SPACE RAD))(-(cadr START) RAD))
      PT2(polar PT1 (/ pi 2.0) (* RAD 2.0))
      PT3(polar PT1 pi LENGTH)
      PT4(polar PT2 pi LENGTH)
      H1(polar PT1 (-(/ pi 2.0)) DLI)
   V1(polar PT1 0.0 DLI))
   (command "LAYER" "S" "OBJECT" "" "CIRCLE" START "D" DIA "LINE" PT1 PT2 PT4 PT3 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT1 PT3 H1 "" "VERTICAL"
   PT1 PT2 V1 "" nil)
   (setq PT5(polar PT2 (/ pi 2.0) SPACE)
      PT6(polar PT5 (/ pi 2.0) DIA)
      PT7(polar PT5 pi LENGTH)
   PT8(polar PT6 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT5 PT6 PT8 PT7 "C")
)
(defun ROUNDT ()           ;Round Tube
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ")
      DIA(getreal "\nEnter Outer Diameter of Round Tube: ")
      RAD(/ DIA 2.0)
      LENGTH(getreal "\nEnter Overall Length of Round Tube: ")
      THICK(getreal "\nEnter Wall Thickness: ")
      ID(- DIA(* THICK 2.0))
      START(list(-(car ORIGIN)RAD)(+(cadr ORIGIN)RAD))
      PT1(list(-(car START)(+ SPACE RAD))(-(cadr START) RAD))
      PT2(polar PT1 (/ pi 2.0) THICK)
      PT3(polar PT2 (/ pi 2.0) ID)
      PT4(polar PT3 (/ pi 2.0) THICK)
      PT5(polar PT1 pi LENGTH)
      PT6(polar PT2 pi LENGTH)
      PT7(polar PT3 pi LENGTH)
      PT8(polar PT4 pi LENGTH)
      H1(polar PT1 (-(/ pi 2.0)) DLI)
      V1(polar PT1 0.0 DLI)
   V2(polar V1 0.0 DLI))  
   (command "LAYER" "S" "OBJECT" "" "CIRCLE" START "DIA" DIA "CIRCLE" START "DIA"
   ID "LINE" PT1 PT4 PT8 PT5 "C")
   (command "LAYER" "S" "HIDDEN" "" "LINE" PT2 PT6 "" "LINE" PT3 PT7 "")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT1 PT5 H1 "" "VERTICAL"
   PT3 PT4 V1 "" "VERTICAL" PT1 PT4 V2 "" nil)
   (setq PT9(polar PT4 (/ pi 2.0) SPACE)
      PT10(polar PT9 (/ pi 2.0) THICK)
      PT11(polar PT10 (/ pi 2.0) ID)
      PT12(polar PT11 (/ pi 2.0) THICK)
      PT13(polar PT9 pi LENGTH)
      PT14(polar PT10 pi LENGTH)
      PT15(polar PT11 pi LENGTH)
   PT16(polar PT12 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT9 PT12 PT16 PT13 "C")
   (command "LAYER" "S" "HIDDEN" "" "LINE" PT10 PT14 "" "LINE" PT11 PT15 "")   
) 
(defun HEXS ()      ;Hex Stock
   (setq ORIGIN(getpoint "\nEnter Origin Point  Lower Right Corner: ")
      SPACE(getreal "\nEnter Space Between Views: ") 
      FLATS(getreal "\nEnter Distance Between Flats: ")
      FL(/ FLATS 2.0)
      LENGTH(getreal "\nEnter Overall Length of Hex Stock: ")
      PT1(polar ORIGIN (/ 120(/ 180 pi)) (/ FL(cos(/ 30(/ 180 pi)))))
      PT2(polar ORIGIN (/ 60(/ 180 pi)) (/ FL(cos(/ 30(/ 180 pi)))))
      DIST(distance PT1 PT2)
      PT3(polar PT2 (/ 300(/ 180 pi)) DIST)
      PT4(polar PT3 (/ 240(/ 180 pi)) DIST)
      PT5(polar PT4 pi DIST)
      PT6(polar PT5 (/ 120(/ 180 pi)) DIST)
      H1(polar PT4 (-(/ pi 2.0)) DLI)
   V1(polar PT6 pi DLI))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT1 PT2 PT3 PT4 PT5 PT6 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT3 PT6 H1 "" "VERTICAL"
   PT5 PT1 V1 "" nil)
   (setq PT7(polar PT6 pi SPACE)
      PT8(polar PT7 (/ pi 2.0) FL)
      PT9(polar PT7 (-(/ pi 2.0)) FL)
      PT10 (polar PT7 pi LENGTH)
      PT11(polar PT8 pi LENGTH) 
   PT12(polar PT9 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "line" PT7 PT10 "" "line" PT8 PT9 PT12 PT11 "C")
   (command "LAYER" "S" "DIMENSION" "" "DIM" "HORIZONTAL" PT9 PT12 H1 "" nil)
   (setq DIST1(distance PT3 PT6)
      PT13(polar PT8 (/ pi 2.0) SPACE)
      PT14(polar PT13 (/ pi 2.0) (-(/ DIST1 2.0)(/ DIST 2.0)))
      PT15(polar PT14 (/ pi 2.0) DIST)
      PT16(polar PT15 (/ pi 2.0) (-(/ DIST1 2.0)(/ DIST 2.0)))
      PT17(polar PT13 pi LENGTH)
      PT18(polar PT14 pi LENGTH)
      PT19(polar PT15 pi LENGTH)
   PT20(polar PT16 pi LENGTH))
   (command "LAYER" "S" "OBJECT" "" "LINE" PT14 PT18 "" "LINE" PT15 PT19 "" "LINE"
   PT13 PT16 PT20 PT17 "C")
)

(defun SELECT()   ;Select Item to Draw
   (setq ITEM(STRCASE(getstring "\nSelect Item <F>Flat <A>Angle <C>Channel <ST>Square Tube <S>Square <R>Round <RT>Round Tube <H>Hex: ")))
   (cond 
      ((= "F" ITEM)(FLAT))   
      ((= "A" ITEM)(ANGLE))
      ((= "C" ITEM)(CHANNEL))
      ((= "ST" ITEM)(SQUARET)) 
      ((= "S" ITEM)(SQUARES))
      ((= "RT" ITEM)(ROUNDT))
      ((= "R" ITEM)(ROUNDS))
      ((= "H" ITEM)(HEXS))
   )
)
(defun RESET ()  ;Reset Settings to Original Values
   (command "LAYER" "S" CL "")
   (setvar "DIMTXT" DT)
   (setvar "DIMASZ" DA)
   (setvar "CMDECHO" CMD)
)
(defun C:SHAPES ()
   (SETTINGS)
   (SELECT)
   (RESET)
); end shapes.lsp
